/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v12 "github.com/kyverno/kyverno/api/kyverno/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// ClusterPolicyLister helps list ClusterPolicies.
// All objects returned here must be treated as read-only.
type ClusterPolicyLister interface {
	// List lists all ClusterPolicies in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v12.ClusterPolicy, err error)
	// Get retrieves the ClusterPolicy from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v12.ClusterPolicy, error)
	ClusterPolicyListerExpansion
}

// clusterPolicyLister implements the ClusterPolicyLister interface.
type clusterPolicyLister struct {
	indexer cache.Indexer
}

// NewClusterPolicyLister returns a new ClusterPolicyLister.
func NewClusterPolicyLister(indexer cache.Indexer) ClusterPolicyLister {
	return &clusterPolicyLister{indexer: indexer}
}

// List lists all ClusterPolicies in the indexer.
func (s *clusterPolicyLister) List(selector labels.Selector) (ret []*v12.ClusterPolicy, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v12.ClusterPolicy))
	})
	return ret, err
}

// Get retrieves the ClusterPolicy from the index for a given name.
func (s *clusterPolicyLister) Get(name string) (*v12.ClusterPolicy, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v12.Resource("clusterpolicy"), name)
	}
	return obj.(*v12.ClusterPolicy), nil
}
